using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;

namespace POX2PC
{
    public partial class Form1 : Form
    {
        private delegate void displayDeleg(int wave);
        private delegate void nextPulseDeleg(int pulse);
        private delegate void nextSpODeleg(int Spo);
        private delegate void nextstatusDeleg(int status);
        private delegate void nextQualityDeleg(int quality);
        
        
        Bitmap bmp;
        Graphics g;
       

        bool tone = false;
        int Status;
        int index = 0;
        int old_wave;
      


        StreamWriter Outfile;
        bool Outfilectr = false;

        public Form1()
        {
            InitializeComponent();
            list_comport();
            bmp = new Bitmap(736, 322);
            g = Graphics.FromImage(bmp);
            

            bar1.Maximum = 256;
           
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Splashscreen Splash = new Splashscreen();
            Splash.Show();
        }

        private void list_comport()
        {
            // Get a list of serial port names. 
            string[] ports = SerialPort.GetPortNames();

            // Display each port name to the console. 
            foreach (string port in ports)
            {
                comToolStripMenuItem.DropDownItems.Add(port, null, new EventHandler(port_Click));
            }
        }

        private void port_Click(object sender, EventArgs e)
        {

            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            serialPort1.ReadBufferSize = 64;
            serialPort1.ReceivedBytesThreshold = 3;

            string Port = sender.ToString();

            serialPort1.PortName = Port;
            try
            {
                serialPort1.Open();
                toolStripStatusLabel1.Text = Port;
                label_Status.Text = "no Data";
                timer3.Start();

            }
            catch
            {
                MessageBox.Show("Serial port " + serialPort1.PortName +
                       " cannot be opened!", "RS232 tester",
                       MessageBoxButtons.OK, MessageBoxIcon.Warning);

            }
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 about = new AboutBox1();
            about.Show();
        }

        private void oNToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (oNToolStripMenuItem.Checked == true)
            {
                oNToolStripMenuItem.Checked = false;
                tone = oNToolStripMenuItem.Checked;
            }
            else if (oNToolStripMenuItem.Checked == false)
            {
                oNToolStripMenuItem.Checked = true;
                tone = oNToolStripMenuItem.Checked;
            }
        }

        private void Form1_FormClosed(object sender, EventArgs e)
        {
            if (Outfilectr == true)
                Outfile.Close();
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            Environment.Exit(0);
        }

        bool startbyte = false;

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
           
            byte buf = 0;
            
                while (serialPort1.BytesToRead > 3)
                {
                    buf = Convert.ToByte(serialPort1.ReadByte());
                    if (buf > 0xfc)
                    {
                        buf = Convert.ToByte(serialPort1.ReadByte());
                    }


                    if ((startbyte == true) && buf > 0xF7)
                    {
                        startbyte = false;
                    }

                    if (buf > 0xf7 && startbyte == false)
                    {
                        //startbyte = true;
                        if (buf == 0xf8)
                        {
                            startbyte = true;
                        }

                        if (buf > 0xf8)
                        {
                            byte RX = buf;
                            buf = Convert.ToByte(serialPort1.ReadByte());
                            if (buf > 0xfc)
                            {
                                buf = Convert.ToByte(serialPort1.ReadByte());
                            }

                            if (RX == 0xf9)
                            {
                                //SPO = buf;
                                this.BeginInvoke(new nextSpODeleg(nextSpO), new object[] { buf });
                            }

                            else if (RX == 0xfa)
                            {
                                //Pulse = buf;
                                this.BeginInvoke(new nextPulseDeleg(nextPulse), new object[] { buf });
                            }
                            else if (RX == 0xfb)
                            {
                                //Status = buf;
                                this.BeginInvoke(new nextstatusDeleg(nextstatus), new object[] { buf });
                            }

                            else if (RX == 0xfc)
                            {
                                //quality = buf;
                                this.BeginInvoke(new nextQualityDeleg(nextQuality), new object[] { buf });
                            }
                            else { }
                        }


                    }
                    else if (startbyte == true)
                    {
                        int wavepoint = 0;

                        wavepoint = Convert.ToInt16(buf);
                        if (wavepoint > 256) wavepoint = 256;
                        if (wavepoint < 0 ) wavepoint = 0;

                        this.BeginInvoke(new displayDeleg(Display), new object[] { wavepoint });
                    }
                    else { }
                }
           
           
        }


        //  81   82   83   84   85   86   87   88   89   90   91   92   93   94   95   96    97    98    99    100
        int[] pt = { 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1046, 1109, 1175, 1244, 1328 };

        private void Piep(double Frequenz, int time)
        {
            const int MinFreq = 0x25;
            const int MaxFreq = 0x7FFF;
            //const int IntFreq  = 1193180;




            if (Frequenz < MinFreq)
                Frequenz = MinFreq;
            else if (Frequenz > MaxFreq)
                Frequenz = MaxFreq;

            Console.Beep((int)(Frequenz), time);

        }

        private void nextPulse(int pulse)
        {
           // if (label_Status.Text == "OK")
            
                timer3.Stop();
                int frq;
                if (Status > 0)
                {
                    label_Puls.Text = "--";
                    pulse = 0;
                }
                else
                {
                    int SpO2 = Convert.ToInt16(label_SpO2.Text);
                    label_Puls.Text = Convert.ToString(pulse);
                    if ((tone == true) && (pulse != 0) && (SpO2 <= 100))     // Have to beep ?
                    {
                        if (SpO2 > 80)
                        {
                            frq = SpO2 - 80;
                        }
                        else
                        {
                            frq = 0;
                        }

                        Piep(pt[frq], 50);
                    }
                }
            timer3.Start();
        }

        private void nextSpO(int Spo)
        {
            //if (label_Status.Text == "OK")
            {
                timer3.Stop();
                if (Status > 0)
                {
                    label_SpO2.Text = "--";
                    Spo = 0;
                }
                else
                {
                    label_SpO2.Text = Convert.ToString(Spo);
                }
            }
            timer3.Start();
        }

        string[] State ={ "OK", "Sensor disconnected", "no Finger in Probe", "low perfusion", "selftest error" };

        private void nextstatus(int status)
        {
            timer3.Stop();
            Status = status;
            if (status == 0x45) status = 4;
            label_Status.Text = State[status];
            timer3.Start();

        }

        private void nextQuality(int quality)
        {
            verticalProgressBar_perfusion.Value = ((quality >> 4) & 0x07);
        }
        

        private void Display(int wave)
        {
            
            if (Status != 0)
            {
                wave = bmp.Height/2;
            }
            if (wave >= bmp.Height)
                wave = bmp.Height -1;
            if (wave <= 0)
                wave = 3;

            bar1.Value = wave;

            if (index < pictureBox1.Width)
            {
                index = index + 1;
            }
            else
            {
                index = 0;
            }

            wave = (bmp.Height - wave) ;

            g.DrawLine(new Pen(Color.White, 2), index+1, 0, index+1, pictureBox1.Height);
            g.DrawLine(new Pen(Color.White, 2), index + 2, 0, index + 2, pictureBox1.Height);

            if (index >= 1)
            {
                g.DrawLine(new Pen(Color.Blue, 1), (index) - 1, old_wave, index, wave);

            }

            old_wave = wave;

            



        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel_time.Text = DateTime.Now.ToLongTimeString();
            if (Outfilectr == true)
                save_file();
        }

        private void GraphUpdate_Tick(object sender, EventArgs e)
        {
            pictureBox1.Image = bmp; 
        }

        private void fileToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (fileToolStripMenuItem1.Checked == false)
            {
                SaveFileDialog dialog = new SaveFileDialog();
                dialog.Title = "Select a file";
                dialog.DefaultExt = "txt";
                dialog.Filter =
                "Text files (*.txt)|*.txt|All files (*.*)|*.*";

                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    Outfile = new StreamWriter(dialog.FileName);
                    Outfilectr = true;
                    fileToolStripMenuItem1.Checked = true;

                    toolStripStatusLabel_Savefile.Text = dialog.FileName;
                }
            }
            else
            {
                Outfile.Close();
                toolStripMenuItem1.Checked = false;
                Outfilectr = false;
                toolStripStatusLabel_Savefile.Text = "No Savefile";

            }
        }

        private void save_file()
        {
            string spostring = "", pulsstring = "";

            if (label_SpO2.Text != "")
            {
                spostring = label_SpO2.Text;
                pulsstring = label_Puls.Text;
            }

            string Output = "S  " + spostring + "  P  " + pulsstring + "  T " + toolStripStatusLabel_time.Text + "    " + label_Status.Text;
            //Outfile.WriteLine("test");
            Outfile.WriteLine(Output);

        }

        private void timer3_Tick(object sender, EventArgs e)
        {
            label_Puls.Text = "--";
            label_SpO2.Text = "--";
            verticalProgressBar_perfusion.Value = 0;
            //bar1.Value = 30;
            label_Status.Text = "no Data";
            

        }

        private void serialPort1_ErrorReceived(object sender, SerialErrorReceivedEventArgs e)
        {
            Console.WriteLine("fehler serielle Port");
        }

        
        
    
    }
    public class VerticalProgressBar : ProgressBar
    {
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams cp = base.CreateParams;
                cp.Style |= 0x04;
                return cp;
            }
        }
    }
}